#!/usr/bin/python
# $Id: create_monster.py 3294 2010-03-29 12:40:50Z haast $
# $URL: https://svn.non-gnu.uvt.nl/uvt-dev/tags/sources/meresco/bzv-8.6.3/tools/monster/create_monster.py $
import os
from urllib import urlopen
from lxml.etree import parse, tostring, fromstring
from ConfigParser import ConfigParser
from sys import argv, stderr

ns = { 'srw' : 'http://www.loc.gov/zing/srw/' }

def showmonsters(monsters):
    print >> stderr, ' showmonsters'

    for m in monsters:
        print >> stderr, 'monster ' + m

def createmonsters(savefile):
    print >> stderr, 'createmonsters'
    print >> stderr, 'savefile: ' + savefile

    save = open(savefile, "w")

    monsters_cfg = config.get('monsters','monsters')
    monsterdefs = [v.strip() for v in config.get('monsters', 'monsters').split(',')]
    monster_list = []

    for monsterdef in monsterdefs:

        repository, samples = monsterdef.split('^')

        url = 'http://search.uvt.nl/sru?version=1.1&operation=searchRetrieve&query=meta.repository.id%20exact%20%22' + \
              repository + \
              '%22'

        sruresponse = parse(urlopen(url))

        recordcount = sruresponse.xpath("//srw:numberOfRecords/text()", ns) [0]
        
        print >> stderr, 'recordcount ' + recordcount

        storage = os.path.join(config.get('database', 'path'), 'storage', repository)
        mod = int(recordcount)/int(samples)

        print >> stderr, 'monsterdef: ' + monsterdef
        print >> stderr, 'storage: ' + storage
        print >> stderr, 'mod: ' + str(mod)

        if not os.path.exists(storage):
            print >> stderr, 'Path not found: "' + storage +'"'
            break

        # FIXME rekening houden met 'deleted' files -> negeren?
        for root, recorddirs, recordfiles in os.walk(storage):
            tel =0
            for recorddir in recorddirs:
                tel = tel + 1
                #print tel, ' ',
                recordid = repository + ':' + recorddir
                if tel % mod == 0:
                    print >> stderr, 'created:' + str(tel) + ':' + recordid
                    save.write(recordid + '\n')

    save.close()


def showconfig(configfile, config):
    print >> stderr, 'inhoud van', configfile, ':'
    for section in config.sections():
        print >> stderr, section
        for option in config.options(section):
            print >> stderr, '>>', option, '=', config.get(section, option)

    source_host = config.get('source', 'host')
    source_port = config.get('source', 'port')

    print >> stderr, '>', source_host
    print >> stderr, '>', source_port

    database = config.get('database', 'path')
    print >> stderr, '>', database
    print >> stderr, 'blabla'

def main():
    args = argv[1:]

    if len(args) != 2:
        print >> stderr, 'usage: %s <config-file> <output-file>' % os.path.basename(argv[0])
        exit()

    configfile = args[0]
    monsterfile = args[1]

    global config
    config = ConfigParser()
    config.read(configfile)
    #showconfig(configfile, config)
    monsters = createmonsters(monsterfile)

if __name__ == '__main__':
    main()

